import glob
import os
import subprocess
import sys

#USER SPECFIFIED PARAMETERS
#Refer to readme for details regarding seting the parameters

#Paths/Filenames -- Edit for your own run
locationOfFastaFiles = "/home/PhagePhisher/FastaFiles/"
supergenomeBase = "background_genome"
path = "/home/PhagePhisher/"
inputReads1 = 'Vader_S6_L001_R1_001.fastq'
inputReads2 = 'Vader_S6_L001_R2_001.fastq'

#Parameters
kmer = '31'
create_supergenome = 0
mapping_option = 2






#PIPELINE

runName = raw_input("Choose Unique Name For Run NO SPACES ")
os.system("mkdir " + path + runName)

#step 1- preprocessing of non-target sequencest
'''Preprocess Non-Target Sequences'''

if (create_supergenome == 0):
	os.system("cat " + locationOfFastaFiles + "*fna > " + locationOfFastaFiles + "temp.fasta")
	first_row= True
	with open(locationOfFastaFiles + "temp.fasta") as f:
    		with open(locationOfFastaFiles + supergenomeBase + ".fasta", "w") as f1:
        		for line in f:
            			if line[0]=='>':
					if first_row:
						f1.write(">" + supergenomeBase + "\n")
						first_row=False
					else:
                				f1.write("NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN\n")
				else:
					f1.write(line)
	os.system("rm " + locationOfFastaFiles + "temp.fasta")

elif (create_supergenome == 1):
	os.system("ls " + locationOfFastaFiles + "*fna > " + locationOfFastaFiles + "temp.x")
	if not os.path.exists(locationOfFastaFiles + "masked"):
		os.makedirs(locationOfFastaFiles + "masked")
	make_masked_genomes='./masker ' + locationOfFastaFiles + ' temp.x ' + locationOfFastaFiles + ' ' + locationOfFastaFiles + 'masked/'
	os.system(make_masked_genomes)
	os.system("rm " + locationOfFastaFiles + "temp.x")

	os.system("cat " + locationOfFastaFiles + "masked/* > " + locationOfFastaFiles + "masked/temp.fasta")
	first_row= True
	with open(locationOfFastaFiles + "masked/temp.fasta") as f:
    		with open(locationOfFastaFiles + supergenomeBase + ".fasta", "w") as f1:
        		for line in f:
            			if line[0]=='>':
					if first_row:
						f1.write(">" + supergenomeBase + "\n")
						first_row=False
					else:
                				f1.write("NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN\n")
				else:
					f1.write(line)
	os.system("rm " + locationOfFastaFiles + "masked/temp.fasta")

#step 2: build bowtie2 index
'''Build bowtie2 Index'''
os.system('bowtie2-build --quiet ' + locationOfFastaFiles + supergenomeBase + '.fasta ' + path + runName + '/' + supergenomeBase)

print("Removing non-viral sequences...")
if (mapping_option == 1):
	unmapped_R1= (path + runName + '/unmapped_' + inputReads1)
	os.system('bowtie2 --quiet --un ' + unmapped_R1 + ' --local -x ' + path + runName + '/' + supergenomeBase + ' -U ' + path + 'data/' + inputReads1)

if (mapping_option == 2):
	os.system('bowtie2 --quiet --un-conc ' + path + runName + '/unmapped_%_' + inputReads1 + ' --local -x ' + path + runName + '/' + supergenomeBase + ' -1 ' + path + 'data/' + inputReads1 + ' -2 ' + path + 'data/' + inputReads2)
	unmapped_R1= (path + runName + '/unmapped_1_' + inputReads1)
	unmapped_R2= (path + runName + '/unmapped_2_' + inputReads1)

if (mapping_option == 3):
	os.system('bowtie2 --quiet --un ' + unmapped_R1 + ' --local -x ' + path + runName + '/' + supergenomeBase + ' -U ' + path + 'data/' + inputReads1)

	#copy the header lines for the unmapped reads to a temporary file, tempOutputR1
	tempfile1 = path + runName + '/tempOutputR1'

	with open(unmapped_R1) as fin, open(tempfile1, 'w') as fout:
	    fout.writelines(islice(fin, None, None, 4))

	#change N:1 to N:2 so that the headers in tempOutputR1 are identical to those in inputReads2
	os.system("sed 's/1:N/2:N/g' <" + tempfile1 + " >" + tempfile1 + "sed")
	os.system("rm " + tempfile1)
	os.system("cp " + tempfile1 + "sed " + tempfile1)
	os.system("rm " + tempfile1 + "sed")

	#take first line from tempOutputR1 and compare to first line of R2
		#if line is the same, write the line and the next three lines to tempfileR2 that will be bowtied
		#if line is not the same, skip ahead 3 lines and try again
	#repeat until finished
	R2=open(path + 'data/' + inputReads2, 'r')
	R2_trimmed=open(path + runName + '/trimmed_' + inputReads2, 'w')
	with open(tempfile1) as tempfile:
		for line in tempfile:
			while True:
				x = R2.readline()
				if x ==line:
					R2_trimmed.write(x)
					x=R2.readline()
					R2_trimmed.write(x)
					x=R2.readline()
					R2_trimmed.write(x)
					x=R2.readline()
					R2_trimmed.write(x)
					break
				else:
					x=R2.readline()
					x=R2.readline()
					x=R2.readline()
	R2_trimmed.close()

	#run trimmed inputReads2 through bowtie2
	trimmed_unmapped_R2=path + runName + '/trimmed_unmapped_' + inputReads2

	os.system('bowtie2 --quiet --un ' + trimmed_unmapped_R2 + ' --local -x ' + path + runName + '/' + supergenomeBase + ' -U ' + path + runName + '/trimmed_' + inputReads2)

	#copy the header lines for the unmapped reads to a temporary file, tempOutputR2
	tempfile2 = path + runName + '/tempOutputR2'

	with open(trimmed_unmapped_R2) as fin, open(tempfile2, 'w') as fout:
	    fout.writelines(islice(fin, None, None, 4))

	#change N:2 to N:1 so that the headers in tempOutputR2 are identical to those in unmapped_inputReads1
	os.system("sed 's/2:N/1:N/g' <" + tempfile2 + " >" + tempfile2 + "sed")
	os.system("rm " + tempfile2)
	os.system("cp " + tempfile2 + "sed " + tempfile2)
	os.system("rm " + tempfile2 + "sed")

	#take first line from tempOutputR2 and compare to first line of the unmapped R1
		#if line is the same, write the line and the next three lines to tempfileR2 that will be bowtied
		#if line is not the same, skip ahead 3 lines and try again
	#repeat until finished
	R1=open(unmapped_R1, 'r')
	R1_trimmed=open(path + runName + '/trimmed_unmapped_' + inputReads1, 'w')
	with open(tempfile2) as tempfile:
		for line in tempfile:
			while True:
				x=R1.readline()
				if x == line:
					R1_trimmed.write(x)
					x=R1.readline()
					R1_trimmed.write(x)
					x=R1.readline()
					R1_trimmed.write(x)
					x=R1.readline()
					R1_trimmed.write(x)
					break
				else:
					x=R1.readline()
					x=R1.readline()
					x=R1.readline()

	#clean up -- delete temporary files
	os.system('rm ' + tempfile1)
	os.system('rm ' + tempfile2)

	unmapped_R1= path + runName + '/trimmed_unmapped_' + inputReads1
	print(unmapped_R1)
	unmapped_R2= trimmed_unmapped_R2
	print(unmapped_R2)


#step 3:Assemble viral reads and prepare for downstream analysis
#NOTE TO USER: VelvetOptimizer can be run prior to identify best hash (k-mer) length for assembly

'''Assemble viral reads in Velvet'''
if (mapping_option == 1):
	velveth_command='velveth '+ path + runName + '/velvet/ ' + kmer + ' -fastq -short ' + unmapped_R1
	os.system(velveth_command)
	velvetg_command='velvetg ' + path + runName + '/velvet/ ' + '  -exp_cov auto'
	os.system(velvetg_command)

if (mapping_option == 2) or (mapping_option == 3):
	velveth_command='velveth '+ path + runName + '/velvet/ ' + kmer + ' -fastq -shortPaired -separate ' + unmapped_R1 + ' ' + unmapped_R2
	os.system(velveth_command)
	velvetg_command='velvetg ' + path + runName + '/velvet/ ' + '  -exp_cov auto'
	os.system(velvetg_command)
